diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/tcp-bbr.h ns-3.34/src/internet/model/tcp-bbr.h
--- ns-3.33/src/internet/model/tcp-bbr.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/internet/model/tcp-bbr.h	2021-07-14 10:31:06.000000000 -0700
@@ -0,0 +1,388 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2018 NITK Surathkal
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Vivek Jain <jain.vivek.anand@gmail.com>
+ *          Viyom Mittal <viyommittal@gmail.com>
+ *          Mohit P. Tahiliani <tahiliani@nitk.edu.in>
+ */
+
+#ifndef TCPBBR_H
+#define TCPBBR_H
+
+#include "ns3/tcp-congestion-ops.h"
+#include "ns3/traced-value.h"
+#include "ns3/data-rate.h"
+#include "ns3/random-variable-stream.h"
+#include "ns3/windowed-filter.h"
+
+class TcpBbrCheckGainValuesTest;
+
+namespace ns3 {
+
+class TcpBbr : public TcpCongestionOps
+{
+public:
+  /**
+   * \brief The number of phases in the BBR ProbeBW gain cycle.
+   */
+  static const uint8_t GAIN_CYCLE_LENGTH = 8;
+
+  /**
+   * \brief BBR uses an eight-phase cycle with the given pacing_gain value
+   * in the BBR ProbeBW gain cycle.
+   */
+  const static double PACING_GAIN_CYCLE [];
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+
+  /**
+   * \brief Constructor
+   */
+  TcpBbr ();
+
+  /**
+   * Copy constructor.
+   * \param sock The socket to copy from.
+   */
+  TcpBbr (const TcpBbr &sock);
+
+  /**
+   * \brief BBR has the following 4 modes for deciding how fast to send:
+   */
+  typedef enum
+  {
+    BBR_STARTUP,        /**< Ramp up sending rate rapidly to fill pipe */
+    BBR_DRAIN,          /**< Drain any queue created during startup */
+    BBR_PROBE_BW,       /**< Discover, share bw: pace around estimated bw */
+    BBR_PROBE_RTT,      /**< Cut inflight to min to probe min_rtt */
+  } BbrMode_t;
+
+  typedef WindowedFilter<DataRate,
+                         MaxFilter<DataRate>,
+                         uint32_t,
+                         uint32_t>
+  MaxBandwidthFilter_t; //!< Definition of max bandwidth filter.
+
+  /**
+   * \brief Literal names of BBR mode for use in log messages
+   */
+  static const char* const BbrModeName[BBR_PROBE_RTT + 1];
+
+  /**
+   * Assign a fixed random variable stream number to the random variables
+   * used by this model.
+   *
+   * \param stream first stream index to use
+   */
+  virtual void SetStream (uint32_t stream);
+
+  virtual std::string GetName () const;
+  virtual bool HasCongControl () const;
+  virtual void CongControl (Ptr<TcpSocketState> tcb,
+                            const TcpRateOps::TcpRateConnection &rc,
+                            const TcpRateOps::TcpRateSample &rs);
+  virtual void CongestionStateSet (Ptr<TcpSocketState> tcb,
+                                   const TcpSocketState::TcpCongState_t newState);
+  virtual void CwndEvent (Ptr<TcpSocketState> tcb,
+                          const TcpSocketState::TcpCAEvent_t event);
+  virtual uint32_t GetSsThresh (Ptr<const TcpSocketState> tcb,
+                                uint32_t bytesInFlight);
+  virtual Ptr<TcpCongestionOps> Fork ();
+
+protected:
+  /**
+   * \brief TcpBbrCheckGainValuesTest friend class (for tests).
+   * \relates TcpBbrCheckGainValuesTest
+   */
+  friend class TcpBbrCheckGainValuesTest;
+
+  /**
+   * \brief Advances pacing gain using cycle gain algorithm, while in BBR_PROBE_BW state
+   */
+  void AdvanceCyclePhase ();
+
+  /**
+   * \brief Checks whether to advance pacing gain in BBR_PROBE_BW state,
+   *  and if allowed calls AdvanceCyclePhase ()
+   * \param tcb the socket state.
+   * \param rs rate sample.
+   */
+  void CheckCyclePhase (Ptr<TcpSocketState> tcb, const TcpRateOps::TcpRateSample &rs);
+
+  /**
+   * \brief Checks whether its time to enter BBR_DRAIN or BBR_PROBE_BW state
+   * \param tcb the socket state.
+   */
+  void CheckDrain (Ptr<TcpSocketState> tcb);
+
+  /**
+   * \brief Identifies whether pipe or BDP is already full
+   * \param rs rate sample.
+   */
+  void CheckFullPipe (const TcpRateOps::TcpRateSample &rs);
+
+  /**
+   * \brief This method handles the steps related to the ProbeRTT state
+   * \param tcb the socket state.
+   * \param rs rate sample.
+   */
+  void CheckProbeRTT (Ptr<TcpSocketState> tcb, const TcpRateOps::TcpRateSample &rs);
+
+  /**
+   * \brief Updates variables specific to BBR_DRAIN state
+   */
+  void EnterDrain ();
+
+  /**
+   * \brief Updates variables specific to BBR_PROBE_BW state
+   */
+  void EnterProbeBW ();
+
+  /**
+   * \brief Updates variables specific to BBR_PROBE_RTT state
+   */
+  void EnterProbeRTT ();
+
+  /**
+   * \brief Updates variables specific to BBR_STARTUP state
+   */
+  void EnterStartup ();
+
+  /**
+   * \brief Called on exiting from BBR_PROBE_RTT state, it eithers invoke EnterProbeBW () or EnterStartup ()
+   */
+  void ExitProbeRTT ();
+
+  /**
+   * \brief Gets BBR state.
+   * \return returns BBR state.
+   */
+  uint32_t GetBbrState ();
+
+  /**
+   * \brief Gets current pacing gain.
+   * \return returns current pacing gain.
+   */
+  double GetPacingGain ();
+
+  /**
+   * \brief Gets current cwnd gain.
+   * \return returns current cwnd gain.
+   */
+  double GetCwndGain ();
+
+  /**
+   * \brief Handles the steps for BBR_PROBE_RTT state.
+   * \param tcb the socket state.
+   */
+  void HandleProbeRTT (Ptr<TcpSocketState> tcb);
+
+  /**
+   * \brief Updates pacing rate if socket is restarting from idle state.
+   * \param tcb the socket state.
+   * \param rs rate sample.
+   */
+  void HandleRestartFromIdle (Ptr<TcpSocketState> tcb, const TcpRateOps::TcpRateSample &rs);
+
+  /**
+   * \brief Estimates the target value for congestion window
+   * \param tcb  the socket state.
+   * \param gain cwnd gain.
+   * \return returns congestion window based on max bandwidth and min RTT.
+   */
+  uint32_t InFlight (Ptr<TcpSocketState> tcb, double gain);
+
+  /**
+   * \brief Intializes the full pipe estimator.
+   */
+  void InitFullPipe ();
+
+  /**
+   * \brief Intializes the pacing rate.
+   * \param tcb  the socket state.
+   */
+  void InitPacingRate (Ptr<TcpSocketState> tcb);
+
+  /**
+   * \brief Intializes the round counting related variables.
+   */
+  void InitRoundCounting ();
+
+  /**
+   * \brief Checks whether to move to next value of pacing gain while in BBR_PROBE_BW.
+   * \param tcb the socket state.
+   * \param rs  rate sample.
+   * \returns true if want to move to next value otherwise false.
+   */
+  bool IsNextCyclePhase (Ptr<TcpSocketState> tcb, const TcpRateOps::TcpRateSample &rs);
+
+  /**
+   * \brief Modulates congestion window in BBR_PROBE_RTT.
+   * \param tcb the socket state.
+   */
+  void ModulateCwndForProbeRTT (Ptr<TcpSocketState> tcb);
+
+  /**
+   * \brief Modulates congestion window in CA_RECOVERY.
+   * \param tcb the socket state.
+   * \param rs rate sample.
+   * \return true if congestion window is updated in CA_RECOVERY.
+   */
+  bool ModulateCwndForRecovery (Ptr<TcpSocketState> tcb, const TcpRateOps::TcpRateSample &rs);
+
+  /**
+   * \brief Helper to restore the last-known good congestion window
+   * \param tcb the socket state.
+   */
+  void RestoreCwnd (Ptr<TcpSocketState> tcb);
+
+  /**
+   * \brief Helper to remember the last-known good congestion window or
+   *        the latest congestion window unmodulated by loss recovery or ProbeRTT.
+   * \param tcb the socket state.
+   */
+  void SaveCwnd (Ptr<const TcpSocketState> tcb);
+
+  /**
+   * \brief Updates congestion window based on the network model.
+   * \param tcb the socket state.
+   * \param rs  rate sample
+   */
+  void SetCwnd (Ptr<TcpSocketState> tcb, const TcpRateOps::TcpRateSample &rs);
+
+  /**
+   * \brief Updates pacing rate based on network model.
+   * \param tcb the socket state.
+   * \param gain pacing gain.
+   */
+  void SetPacingRate (Ptr<TcpSocketState> tcb, double gain);
+
+  /**
+   * \brief Updates send quantum based on the network model.
+   * \param tcb the socket state.
+   */
+  void SetSendQuantum (Ptr<TcpSocketState> tcb);
+
+  /**
+   * \brief Updates maximum bottleneck.
+   * \param tcb the socket state.
+   * \param rs rate sample.
+   */
+  void UpdateBtlBw (Ptr<TcpSocketState> tcb, const TcpRateOps::TcpRateSample &rs);
+
+  /**
+   * \brief Updates control parameters congestion windowm, pacing rate, send quantum.
+   * \param tcb the socket state.
+   * \param rs rate sample.
+   */
+  void UpdateControlParameters (Ptr<TcpSocketState> tcb, const TcpRateOps::TcpRateSample &rs);
+
+  /**
+   * \brief Updates BBR network model (Maximum bandwidth and minimum RTT).
+   * \param tcb the socket state.
+   * \param rs rate sample.
+   */
+  void UpdateModelAndState (Ptr<TcpSocketState> tcb, const TcpRateOps::TcpRateSample &rs);
+
+  /**
+   * \brief Updates round counting related variables.
+   * \param tcb the socket state.
+   * \param rs rate sample.
+   */
+  void UpdateRound (Ptr<TcpSocketState> tcb, const TcpRateOps::TcpRateSample &rs);
+
+  /**
+   * \brief Updates minimum RTT.
+   * \param tcb the socket state.
+   */
+  void UpdateRTprop (Ptr<TcpSocketState> tcb);
+
+  /**
+   * \brief Updates target congestion window.
+   * \param tcb the socket state.
+   */
+  void UpdateTargetCwnd (Ptr<TcpSocketState> tcb);
+
+  /**
+   * \brief Sets BBR state.
+   * \param state BBR state.
+   */
+  void SetBbrState (BbrMode_t state);
+
+  /**
+  * \brief Find Cwnd increment based on ack aggregation.
+  * \return uint32_t aggregate cwnd.
+  */
+  uint32_t AckAggregationCwnd();
+
+  /**
+  * \brief Estimates max degree of aggregation.
+  * \param tcb the socket state.
+  * \param rs rate sample.
+  */
+  void UpdateAckAggregation(Ptr<TcpSocketState> tcb, const TcpRateOps::TcpRateSample &rs);
+
+private:
+  BbrMode_t   m_state        {BbrMode_t::BBR_STARTUP};           //!< Current state of BBR state machine
+  MaxBandwidthFilter_t   m_maxBwFilter;                          //!< Maximum bandwidth filter
+  uint32_t    m_bandwidthWindowLength       {0};                 //!< A constant specifying the length of the BBR.BtlBw max filter window, default 10 packet-timed round trips.
+  double      m_pacingGain                  {0};                 //!< The dynamic pacing gain factor
+  double      m_cWndGain                    {0};                 //!< The dynamic congestion window gain factor
+  double      m_highGain                    {0};                 //!< A constant specifying highest gain factor, default is 2.89
+  bool        m_isPipeFilled                {false};             //!< A boolean that records whether BBR has filled the pipe
+  uint32_t    m_minPipeCwnd                 {0};                 //!< The minimal congestion window value BBR tries to target, default 4 Segment size
+  uint32_t    m_roundCount                  {0};                 //!< Count of packet-timed round trips
+  bool        m_roundStart                  {false};             //!< A boolean that BBR sets to true once per packet-timed round trip
+  uint32_t    m_nextRoundDelivered          {0};                 //!< Denotes the end of a packet-timed round trip
+  Time        m_probeRttDuration            {MilliSeconds (200)};//!< A constant specifying the minimum duration for which ProbeRTT state, default 200 millisecs
+  Time        m_probeRtPropStamp            {Seconds (0)};       //!< The wall clock time at which the current BBR.RTProp sample was obtained.
+  Time        m_probeRttDoneStamp           {Seconds (0)};       //!< Time to exit from BBR_PROBE_RTT state
+  bool        m_probeRttRoundDone           {false};             //!< True when it is time to exit BBR_PROBE_RTT
+  bool        m_packetConservation          {false};             //!< Enable/Disable packet conservation mode
+  uint32_t    m_priorCwnd                   {0};                 //!< The last-known good congestion window
+  bool        m_idleRestart                 {false};             //!< When restarting from idle, set it true
+  uint32_t    m_targetCWnd                  {0};                 //!< Target value for congestion window, adapted to the estimated BDP
+  DataRate    m_fullBandwidth               {0};                 //!< Value of full bandwidth recorded
+  uint32_t    m_fullBandwidthCount          {0};                 //!< Count of full bandwidth recorded consistently
+  Time        m_rtProp                      {Time::Max ()};      //!< Estimated two-way round-trip propagation delay of the path, estimated from the windowed minimum recent round-trip delay sample.
+  uint32_t    m_sendQuantum                 {0};                 //!< The maximum size of a data aggregate scheduled and transmitted together
+  Time        m_cycleStamp                  {Seconds (0)};       //!< Last time gain cycle updated
+  uint32_t    m_cycleIndex                  {0};                 //!< Current index of gain cycle
+  bool        m_rtPropExpired               {false};             //!< A boolean recording whether the BBR.RTprop has expired
+  Time        m_rtPropFilterLen             {Seconds (10)};      //!< A constant specifying the length of the RTProp min filter window, default 10 secs.
+  Time        m_rtPropStamp                 {Seconds (0)};       //!< The wall clock time at which the current BBR.RTProp sample was obtained
+  bool        m_isInitialized               {false};             //!< Set to true after first time initializtion variables
+  Ptr<UniformRandomVariable> m_uv           {nullptr};           //!< Uniform Random Variable
+  uint64_t    m_delivered                   {0};                 //!< The total amount of data in bytes delivered so far
+  uint32_t    m_appLimited                  {0};                 //!< The index of the last transmitted packet marked as application-limited
+  uint32_t    m_txItemDelivered             {0};                 //!< The number of bytes already delivered at the time of new packet transmission
+  uint32_t    m_extraAckedGain              {1};                 //!< Gain factor for adding extra ack to cwnd
+  uint32_t    m_extraAcked [2]              {0, 0};              //!< Maximum excess data acked in epoch
+  uint32_t    m_extraAckedWinRtt            {0};                 //!< Age of extra acked in rtt
+  uint32_t    m_extraAckedWinRttLength      {5};                 //!< Window length of extra acked window
+  uint32_t    m_ackEpochAckedResetThresh    {1 << 17};           //!< Max allowed val for m_ackEpochAcked, after which sampling epoch is reset 
+  uint32_t    m_extraAckedIdx               {0};                 //!< Current index in extra acked array
+  Time        m_ackEpochTime                {Seconds(0)};        //!< Starting of ACK sampling epoch time
+  uint32_t    m_ackEpochAcked               {0};                 //!< Bytes ACked in sampling epoch
+  bool        m_hasSeenRtt                  {false};             //!< Have we seen RTT sample yet?
+};
+
+} // namespace ns3
+#endif // TCPBBR_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/tcp-cubic.h ns-3.34/src/internet/model/tcp-cubic.h
--- ns-3.33/src/internet/model/tcp-cubic.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/tcp-cubic.h	2021-07-14 10:31:06.000000000 -0700
@@ -77,6 +77,11 @@
   static TypeId GetTypeId (void);
 
   TcpCubic ();
+
+  /**
+   * Copy constructor
+   * \param sock Socket to copy
+   */
   TcpCubic (const TcpCubic& sock);
 
   virtual std::string GetName () const;
@@ -133,13 +138,20 @@
 private:
   /**
    * \brief Reset HyStart parameters
+   * \param tcb Transmission Control Block of the connection
    */
   void HystartReset (Ptr<const TcpSocketState> tcb);
 
+  /**
+   * \brief Reset Cubic parameters
+   * \param tcb Transmission Control Block of the connection
+   */
   void CubicReset (Ptr<const TcpSocketState> tcb);
 
   /**
    * \brief Cubic window update after a new ack received
+   * \param tcb Transmission Control Block of the connection
+   * \returns the congestion window update counter
    */
   uint32_t Update (Ptr<TcpSocketState> tcb);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/tcp-l4-protocol.cc ns-3.34/src/internet/model/tcp-l4-protocol.cc
--- ns-3.33/src/internet/model/tcp-l4-protocol.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/tcp-l4-protocol.cc	2021-07-14 10:31:06.000000000 -0700
@@ -42,6 +42,7 @@
 #include "tcp-socket-factory-impl.h"
 #include "tcp-socket-base.h"
 #include "tcp-congestion-ops.h"
+#include "tcp-cubic.h"
 #include "tcp-recovery-ops.h"
 #include "tcp-prr-recovery.h"
 #include "rtt-estimator.h"
@@ -79,7 +80,7 @@
                    MakeTypeIdChecker ())
     .AddAttribute ("SocketType",
                    "Socket type of TCP objects.",
-                   TypeIdValue (TcpNewReno::GetTypeId ()),
+                   TypeIdValue (TcpCubic::GetTypeId ()),
                    MakeTypeIdAccessor (&TcpL4Protocol::m_congestionTypeId),
                    MakeTypeIdChecker ())
     .AddAttribute ("RecoveryType",
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/tcp-linux-reno.cc ns-3.34/src/internet/model/tcp-linux-reno.cc
--- ns-3.33/src/internet/model/tcp-linux-reno.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/tcp-linux-reno.cc	2021-07-14 10:31:06.000000000 -0700
@@ -77,6 +77,13 @@
   NS_LOG_FUNCTION (this << tcb << segmentsAcked);
 
   uint32_t w = tcb->m_cWnd / tcb->m_segmentSize;
+
+  // Floor w to 1 if w == 0 
+  if (w == 0)
+    {
+      w = 1;
+    }
+
   NS_LOG_DEBUG ("w in segments " << w << " m_cWndCnt " << m_cWndCnt << " segments acked " << segmentsAcked);
   if (m_cWndCnt >= w)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/tcp-linux-reno.h ns-3.34/src/internet/model/tcp-linux-reno.h
--- ns-3.33/src/internet/model/tcp-linux-reno.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/tcp-linux-reno.h	2021-07-14 10:31:06.000000000 -0700
@@ -55,7 +55,18 @@
   virtual Ptr<TcpCongestionOps> Fork ();
 
 protected:
+  /**
+   * Slow start phase handler
+   * \param tcb Transmission Control Block of the connection
+   * \param segmentsAcked count of segments acked
+   * \return Number of segments acked minus the difference between the receiver and sender Cwnd
+   */
   virtual uint32_t SlowStart (Ptr<TcpSocketState> tcb, uint32_t segmentsAcked);
+  /**
+   * Congestion avoidance phase handler
+   * \param tcb Transmission Control Block of the connection
+   * \param segmentsAcked count of segments acked
+   */
   virtual void CongestionAvoidance (Ptr<TcpSocketState> tcb, uint32_t segmentsAcked);
 
 private:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/tcp-rate-ops.h ns-3.34/src/internet/model/tcp-rate-ops.h
--- ns-3.33/src/internet/model/tcp-rate-ops.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/tcp-rate-ops.h	2021-07-14 10:31:06.000000000 -0700
@@ -75,7 +75,7 @@
 
   /**
    * \brief If a gap is detected between sends, it means we are app-limited.
-   * \return TODO What the Linux kernel is setting in tp->app_limited?
+   * TODO What the Linux kernel is setting in tp->app_limited?
    * https://elixir.bootlin.com/linux/latest/source/net/ipv4/tcp_rate.c#L177
    *
    * \param cWnd Congestion Window
@@ -104,6 +104,7 @@
    * (S)ACK received
    * \param lost number of segments that we detected as lost after the reception
    * of the most recent (S)ACK
+   * \param priorInFlight number of segments previously considered in flight
    * \param is_sack_reneg Is SACK reneged?
    * \param minRtt Minimum RTT so far
    * \return The TcpRateSample that will be used for CA
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/tcp-recovery-ops.h ns-3.34/src/internet/model/tcp-recovery-ops.h
--- ns-3.33/src/internet/model/tcp-recovery-ops.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/tcp-recovery-ops.h	2021-07-14 10:31:06.000000000 -0700
@@ -120,7 +120,6 @@
    * The function is called when the TcpSocketState is changed from CA_RECOVERY.
    *
    * \param tcb internal congestion state
-   * \param isSackEnabled
    */
   virtual void ExitRecovery (Ptr<TcpSocketState> tcb) = 0;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/tcp-socket-base.cc ns-3.34/src/internet/model/tcp-socket-base.cc
--- ns-3.33/src/internet/model/tcp-socket-base.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/tcp-socket-base.cc	2021-07-14 10:31:06.000000000 -0700
@@ -1811,6 +1811,7 @@
   m_txBuffer->DiscardUpTo (ackNumber, MakeCallback (&TcpRateOps::SkbDelivered, m_rateOps));
 
   uint32_t currentDelivered = static_cast<uint32_t> (m_rateOps->GetConnectionRate ().m_delivered - previousDelivered);
+  m_tcb->m_lastAckedSackedBytes = currentDelivered;
 
   if (m_tcb->m_congState == TcpSocketState::CA_CWR && (ackNumber > m_recover))
     {
@@ -3520,13 +3521,6 @@
     }
 }
 
-/**
- * \brief Estimate the RTT
- *
- * Called by ForwardUp() to estimate RTT.
- *
- * \param tcpHeader TCP header for the incoming packet
- */
 void
 TcpSocketBase::EstimateRtt (const TcpHeader& tcpHeader)
 {
@@ -3546,6 +3540,11 @@
               Ptr<const TcpOptionTS> ts;
               ts = DynamicCast<const TcpOptionTS> (tcpHeader.GetOption (TcpOption::TS));
               m = TcpOptionTS::ElapsedTimeFromTsValue (ts->GetEcho ());
+              if (m.IsZero ())
+                {
+                  NS_LOG_LOGIC ("TcpSocketBase::EstimateRtt - RTT calculated from TcpOption::TS is zero, approximating to 1us.");
+                  m = MicroSeconds (1);
+                }
             }
           else
             {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/tcp-socket-base.h ns-3.34/src/internet/model/tcp-socket-base.h
--- ns-3.33/src/internet/model/tcp-socket-base.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/tcp-socket-base.h	2021-07-14 10:31:06.000000000 -0700
@@ -533,6 +533,7 @@
   /**
    * \brief Checks for CE codepoint
    *
+   * \param tos the TOS byte to check
    * \return true if TOS has CE codepoint set; otherwise false
    */
   inline bool CheckEcnCe (uint8_t tos) const
@@ -567,7 +568,7 @@
 
   /**
    * \brief Enable or disable pacing of the initial window
-   * \param pacing Boolean to enable or disable pacing of the initial window
+   * \param paceWindow Boolean to enable or disable pacing of the initial window
    */
   void SetPaceInitialWindow (bool paceWindow);
 
@@ -696,6 +697,7 @@
    * \param seq the sequence number of packet's TCP header
    * \param tcpHeaderSize the size of packet's TCP header
    * \param tcpPayloadSize the size of TCP payload
+   * \return true if the TCP segment is valid
    */
   bool IsValidTcpSegment (const SequenceNumber32 seq, const uint32_t tcpHeaderSize,
                           const uint32_t tcpPayloadSize);
@@ -1001,7 +1003,6 @@
    * \param oldHeadSequence value of HeadSequence before ack
    * updated with SACK information
    * \param currentDelivered The number of bytes (S)ACKed
-   * \return the number of bytes (newly) acked, or 0 if it was a dupack
    */
   virtual void ProcessAck (const SequenceNumber32 &ackNumber, bool scoreboardUpdated,
                            uint32_t currentDelivered, const SequenceNumber32 &oldHeadSequence);
@@ -1217,8 +1218,6 @@
 
   /**
    * \brief Dynamically update the pacing rate
-   *
-   * \param tcb internal congestion state
    */
   void UpdatePacingRate (void);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/tcp-socket-state.cc ns-3.34/src/internet/model/tcp-socket-state.cc
--- ns-3.33/src/internet/model/tcp-socket-state.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/tcp-socket-state.cc	2021-07-14 10:31:06.000000000 -0700
@@ -116,7 +116,10 @@
     m_bytesInFlight (other.m_bytesInFlight),
     m_lastRtt (other.m_lastRtt),
     m_ecnMode (other.m_ecnMode),
-    m_useEcn (other.m_useEcn)
+    m_useEcn (other.m_useEcn),
+    m_ectCodePoint (other.m_ectCodePoint),
+    m_lastAckedSackedBytes (other.m_lastAckedSackedBytes)
+
 {
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/tcp-socket-state.h ns-3.34/src/internet/model/tcp-socket-state.h
--- ns-3.33/src/internet/model/tcp-socket-state.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/tcp-socket-state.h	2021-07-14 10:31:06.000000000 -0700
@@ -88,6 +88,9 @@
   } TcpCongState_t;
 
   // Note: "not triggered" events are currently not triggered by the code.
+  /**
+   * \brief Congestion avoidance events
+   */
   typedef enum
   {
     CA_EVENT_TX_START,     /**< first transmit when no packets in flight */
@@ -204,6 +207,8 @@
 
   EcnCodePoint_t         m_ectCodePoint {Ect0};  //!< ECT code point to use
 
+  uint32_t               m_lastAckedSackedBytes {0}; //!< The number of bytes acked and sacked as indicated by the current ACK received. This is similar to acked_sacked variable in Linux
+
   /**
    * \brief Get cwnd in segments rather than bytes
    *
@@ -224,6 +229,9 @@
     return m_ssThresh / m_segmentSize;
   }
 
+  /**
+   * Callback to send an empty packet
+   */
   Callback <void, uint8_t> m_sendEmptyPacketCallback;
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/tcp-tx-buffer.cc ns-3.34/src/internet/model/tcp-tx-buffer.cc
--- ns-3.33/src/internet/model/tcp-tx-buffer.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/tcp-tx-buffer.cc	2021-07-14 10:31:06.000000000 -0700
@@ -582,11 +582,6 @@
   NS_FATAL_ERROR ("This point is not reachable");
 }
 
-static bool AreEquals (const bool &first, const bool &second)
-{
-  return first ? second : !second;
-}
-
 void
 TcpTxBuffer::MergeItems (TcpTxItem *t1, TcpTxItem *t2) const
 {
@@ -594,15 +589,15 @@
   NS_LOG_FUNCTION (this << *t1 << *t2);
   NS_LOG_INFO ("Merging " << *t2 << " into " << *t1);
 
-  NS_ASSERT_MSG (AreEquals (t1->m_sacked, t2->m_sacked),
+  NS_ASSERT_MSG (t1->m_sacked == t2->m_sacked,
                  "Merging one sacked and another not sacked. Impossible");
-  NS_ASSERT_MSG (AreEquals (t1->m_lost, t2->m_lost),
+  NS_ASSERT_MSG (t1->m_lost == t2->m_lost,
                  "Merging one lost and another not lost. Impossible");
 
   // If one is retrans and the other is not, cancel the retransmitted flag.
   // We are merging this segment for the retransmit, so the count will
   // be updated in MarkTransmittedSegment.
-  if (! AreEquals (t1->m_retrans, t2->m_retrans))
+  if (t1->m_retrans != t2->m_retrans)
     {
       if (t1->m_retrans)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/tcp-tx-buffer.h ns-3.34/src/internet/model/tcp-tx-buffer.h
--- ns-3.33/src/internet/model/tcp-tx-buffer.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/tcp-tx-buffer.h	2021-07-14 10:31:06.000000000 -0700
@@ -168,6 +168,7 @@
 
   /**
    * \brief check whether SACK is used on the corresponding TCP socket
+   * \return true if SACK is used
    */
   bool IsSackEnabled (void) const;
 
@@ -304,8 +305,6 @@
    * as lost for an external class
    *
    * \param seq sequence to check
-   * \param dupThresh dupAck threshold
-   * \param segmentSize segment size
    * \return true if the sequence is supposed to be lost, false otherwise
    */
   bool IsLost (const SequenceNumber32 &seq) const;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/tcp-tx-item.h ns-3.34/src/internet/model/tcp-tx-item.h
--- ns-3.33/src/internet/model/tcp-tx-item.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/tcp-tx-item.h	2021-07-14 10:31:06.000000000 -0700
@@ -102,7 +102,7 @@
   bool m_retrans       {false};      //!< Indicates if the segment is retransmitted
 
 private:
-  // Only TcpTxBuffer is allower to touch this part of the TcpTxItem, to manage
+  // Only TcpTxBuffer is allowed to touch this part of the TcpTxItem, to manage
   // its internal lists and counters
   friend class TcpTxBuffer;
 
